Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/src/Parameters.cpp	(revision 116)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/src/Parameters.cpp	(revision 117)
@@ -30,6 +30,9 @@
    uint32_t              * ooo_engine_nb_inst_branch_complete   ,//[nb_ooo_engine]
    uint32_t              * nb_inst_insert                       ,//[nb_ooo_engine]
-   uint32_t              * nb_inst_issue                        ,//[nb_ooo_engine]
+   uint32_t              * nb_inst_reexecute                    ,//[nb_ooo_engine]
+   uint32_t              * nb_inst_issue_queue                  ,//[nb_ooo_engine]
+   uint32_t              * nb_inst_issue_slot                   ,//[nb_ooo_engine]
    uint32_t             ** nb_inst_execute                      ,//[nb_ooo_engine][ooo_engine_nb_execute_loop]
+   bool                  * issue_queue_in_order                 ,//[nb_ooo_engine]
    uint32_t              * nb_read_unit                         ,//[nb_execute_loop]
    uint32_t              * nb_write_unit                        ,//[nb_execute_loop]
@@ -44,5 +47,6 @@
    Tpriority_t             dispatch_priority                    ,
    Tload_balancing_t       dispatch_load_balancing              ,
-   bool               **** table_dispatch                       ,//[nb_ooo_engine][nb_inst_issue][execute_loop][nb_read_unit]
+   bool               **** table_dispatch                       ,//[nb_ooo_engine][nb_inst_issue_slot][execute_loop][nb_read_unit]
+   bool                *** table_issue_type                     ,//                                   [execute_loop][nb_read_unit][nb_type]
    uint32_t             ** translate_ooo_engine_num_front_end   ,//[nb_ooo_engine][ooo_engine_nb_front_end]
    uint32_t             ** translate_ooo_engine_num_execute_loop,//[nb_ooo_engine][ooo_engine_nb_execute_loop]
@@ -63,6 +67,9 @@
     _ooo_engine_nb_inst_branch_complete    = ooo_engine_nb_inst_branch_complete   ;
     _nb_inst_insert                        = nb_inst_insert                       ;
-    _nb_inst_issue                         = nb_inst_issue                        ;
+    _nb_inst_reexecute                     = nb_inst_reexecute                    ;
+    _nb_inst_issue_queue                   = nb_inst_issue_queue                  ;
+    _nb_inst_issue_slot                    = nb_inst_issue_slot                   ;
     _nb_inst_execute                       = nb_inst_execute                      ;
+    _issue_queue_in_order                  = issue_queue_in_order                 ;
     _nb_read_unit                          = nb_read_unit                         ;
     _nb_write_unit                         = nb_write_unit                        ;
@@ -70,4 +77,5 @@
     _dispatch_load_balancing               = dispatch_load_balancing              ;
     _table_dispatch                        = table_dispatch                       ;
+    _table_issue_type                      = table_issue_type                     ;
     _translate_ooo_engine_num_front_end    = translate_ooo_engine_num_front_end   ;
     _translate_ooo_engine_num_execute_loop = translate_ooo_engine_num_execute_loop;
@@ -78,5 +86,4 @@
     ALLOC1(_link_ooo_engine_with_front_end,uint32_t,_nb_front_end);
     ALLOC1(_translate_num_front_end_to_ooo_engine_front_end_id,uint32_t,_nb_front_end);
-
     for (uint32_t i=0; i<_nb_ooo_engine; ++i)
       for (uint32_t j=0; j<_ooo_engine_nb_front_end[i]; ++j)
@@ -102,5 +109,5 @@
 
     ALLOC2(_execute_loop_nb_inst_insert,uint32_t,_nb_execute_loop,_execute_loop_nb_ooo_engine[it1]);
-    ALLOC2(_execute_loop_nb_inst_issue ,uint32_t,_nb_execute_loop,_execute_loop_nb_ooo_engine[it1]);
+    ALLOC2(_execute_loop_nb_inst_issue_slot ,uint32_t,_nb_execute_loop,_execute_loop_nb_ooo_engine[it1]);
 
     for (uint32_t i=0; i<_nb_execute_loop; ++i)
@@ -108,6 +115,6 @@
         {
           uint32_t num_ooo_engine = _translate_execute_loop_num_ooo_engine [i][j];
-          _execute_loop_nb_inst_issue  [i][j] = _nb_inst_issue  [num_ooo_engine];
-          _execute_loop_nb_inst_insert [i][j] = _nb_inst_insert [num_ooo_engine];
+          _execute_loop_nb_inst_issue_slot [i][j] = _nb_inst_issue_slot [num_ooo_engine];
+          _execute_loop_nb_inst_insert     [i][j] = _nb_inst_insert     [num_ooo_engine];
         }
 
@@ -118,5 +125,6 @@
     _max_nb_write_unit                      = max<uint32_t>(_nb_write_unit             ,_nb_execute_loop);
     _max_nb_inst_insert                     = max<uint32_t>(_nb_inst_insert            ,_nb_ooo_engine);
-    _max_nb_inst_issue                      = max<uint32_t>(_nb_inst_issue             ,_nb_ooo_engine);
+    _max_nb_inst_issue_queue                = max<uint32_t>(_nb_inst_issue_queue       ,_nb_ooo_engine);
+    _max_nb_inst_issue_slot                 = max<uint32_t>(_nb_inst_issue_slot        ,_nb_ooo_engine);
     _max_nb_read_unit                       = max<uint32_t>(_nb_read_unit              ,_nb_execute_loop);
 
@@ -171,5 +179,5 @@
     log_begin(Core_Glue,FUNCTION);
 
-    DELETE2(_execute_loop_nb_inst_issue,_nb_execute_loop,_execute_loop_nb_ooo_engine[it1]);
+    DELETE2(_execute_loop_nb_inst_issue_slot,_nb_execute_loop,_execute_loop_nb_ooo_engine[it1]);
     DELETE2(_execute_loop_nb_inst_insert,_nb_execute_loop,_execute_loop_nb_ooo_engine[it1]);
     DELETE2(_translate_num_execute_loop_to_ooo_engine_execute_loop_id, _nb_execute_loop,_execute_loop_nb_ooo_engine[it1]);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access_genMealy_req.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access_genMealy_req.cpp	(revision 116)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access_genMealy_req.cpp	(revision 117)
@@ -52,4 +52,6 @@
 		uint32_t   num_port       = _param->_table_routing[num_execute_loop][num_load_store_unit][num_cache_access];
 		Tcontrol_t dcache_req_ack = PORT_READ(in_DCACHE_REQ_ACK [num_port]);
+
+                log_printf(TRACE,Dcache_Access,FUNCTION,"  * num_port      : %d",num_port);
 		
 #ifdef STATISTICS
@@ -66,8 +68,15 @@
 		    lsq_req_ack [num_execute_loop][num_load_store_unit][num_cache_access] = dcache_req_ack;
 		    
+                    log_printf(TRACE,Dcache_Access,FUNCTION,"    * kane - dcache");
+
 		    if (_param->_have_port_dcache_thread_id)
                       {
 		    Tcontext_t num_context = (_param->_have_port_lsq_thread_id [num_execute_loop][num_load_store_unit])?PORT_READ(in_LSQ_REQ_THREAD_ID [num_execute_loop][num_load_store_unit][num_cache_access]):0;
-                    PORT_WRITE(out_DCACHE_REQ_THREAD_ID [num_port], _param->_translate_load_store_unit_to_thread[num_execute_loop][num_load_store_unit][num_context]);
+                    Tcontext_t num_thread  = _param->_translate_load_store_unit_to_thread[num_execute_loop][num_load_store_unit][num_context];
+                    log_printf(TRACE,Dcache_Access,FUNCTION,"    * num_context : %d",num_context);
+                    log_printf(TRACE,Dcache_Access,FUNCTION,"    * num_thread  : %d",num_thread );
+
+
+                    PORT_WRITE(out_DCACHE_REQ_THREAD_ID [num_port], num_thread);
                       }
 // 		    PORT_WRITE(out_DCACHE_REQ_THREAD_ID [num_port], ((num_execute_loop    << _param->_shift_num_execute_loop   )+
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_genMealy_req.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_genMealy_req.cpp	(revision 116)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_genMealy_req.cpp	(revision 117)
@@ -50,4 +50,6 @@
 	    Tcontrol_t icache_req_ack = PORT_READ(in_ICACHE_REQ_ACK [num_port]);
 
+            log_printf(TRACE,Dcache_Access,FUNCTION,"  * num_port      : %d",num_port);
+
 #ifdef STATISTICS
 	    if (icache_req_ack)
@@ -63,6 +65,14 @@
 		context_req_ack [num_front_end][num_context] = icache_req_ack;
 
+                log_printf(TRACE,Dcache_Access,FUNCTION,"    * kane - icache");
+
 		if (_param->_have_port_icache_thread_id)
-		PORT_WRITE(out_ICACHE_REQ_THREAD_ID [num_port], _param->_translate_context_to_thread[num_front_end][num_context]);
+                  {
+                Tcontext_t num_thread = _param->_translate_context_to_thread[num_front_end][num_context];
+                log_printf(TRACE,Dcache_Access,FUNCTION,"    * num_context : %d",num_context);
+                log_printf(TRACE,Dcache_Access,FUNCTION,"    * num_thread  : %d",num_thread );
+
+		PORT_WRITE(out_ICACHE_REQ_THREAD_ID [num_port], num_thread);
+                  }
 // 		if (_param->_have_port_icache_packet_id)
                 if (_param->_have_port_packet_id [num_front_end][num_context])
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Parameters_msg_error.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Parameters_msg_error.cpp	(revision 116)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Parameters_msg_error.cpp	(revision 117)
@@ -44,15 +44,18 @@
     
     for (uint32_t i=0; i<_nb_front_end; i++)
-      for (uint32_t j=0; j<_nb_context [i]; j++)
-        {
-          uint32_t num_thread = _translate_context_to_thread [i][j];
-          if (num_thread >= _nb_thread)
-            test.error(toString(_("Context [%d][%d] is linked with an invalid thread id.\n"),i,j));
-          else
-            if (thread_link [num_thread] == true)
-              test.error(toString(_("Context [%d][%d] is linked with an already used thread id.\n"),i,j));
+      {
+        for (uint32_t j=0; j<_nb_context [i]; j++)
+          {
+            uint32_t num_thread = _translate_context_to_thread [i][j];
+
+            if (num_thread >= _nb_thread)
+              test.error(toString(_("Context [%d][%d] is linked with an invalid thread id.\n"),i,j));
             else
-              thread_link [num_thread] = true;
-        }
+              if (thread_link [num_thread] == true)
+                test.error(toString(_("Context [%d][%d] is linked with an already used thread id.\n"),i,j));
+              else
+                thread_link [num_thread] = true;
+          }
+      }
 
     for (uint32_t i=0; i<_nb_thread; ++i)
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Functionnal_unit_genMealy.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Functionnal_unit_genMealy.cpp	(revision 116)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Functionnal_unit_genMealy.cpp	(revision 117)
@@ -26,17 +26,20 @@
     log_function(Functionnal_unit,FUNCTION,_name.c_str());
 
-    {
-      internal_EXECUTE_OUT_VAL = (reg_BUSY_OUT and (_execute_operation_out->_timing._latence == 0));
-      
-      PORT_WRITE(out_EXECUTE_OUT_VAL          , internal_EXECUTE_OUT_VAL);
-    }
-
-    {
-      internal_EXECUTE_IN_ACK = (not reg_BUSY_IN or
-                                 (reg_BUSY_IN and (not reg_BUSY_OUT or 
-                                                   (internal_EXECUTE_OUT_VAL and PORT_READ(in_EXECUTE_OUT_ACK)))));
-      
-      PORT_WRITE(out_EXECUTE_IN_ACK           , internal_EXECUTE_IN_ACK);
-    }
+    if (PORT_READ(in_NRESET) != 0)
+      {
+        {
+          internal_EXECUTE_OUT_VAL = (reg_BUSY_OUT and (_execute_operation_out->_timing._latence == 0));
+          
+          PORT_WRITE(out_EXECUTE_OUT_VAL          , internal_EXECUTE_OUT_VAL);
+        }
+        
+        {
+          internal_EXECUTE_IN_ACK = (not reg_BUSY_IN or
+                                     (reg_BUSY_IN and (not reg_BUSY_OUT or 
+                                                       (internal_EXECUTE_OUT_VAL and PORT_READ(in_EXECUTE_OUT_ACK)))));
+          
+          PORT_WRITE(out_EXECUTE_IN_ACK           , internal_EXECUTE_IN_ACK);
+        }
+      }
 
     log_end(Functionnal_unit,FUNCTION);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Functionnal_unit_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Functionnal_unit_transition.cpp	(revision 116)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Functionnal_unit_transition.cpp	(revision 117)
@@ -60,5 +60,4 @@
 
         if (reg_BUSY_IN and not reg_BUSY_OUT)
-//      if (not reg_BUSY_OUT_old or)
 	  {
 	    reg_BUSY_OUT = reg_BUSY_IN;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/SelfTest/src/test2.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/SelfTest/src/test2.cpp	(revision 116)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/SelfTest/src/test2.cpp	(revision 117)
@@ -70,5 +70,58 @@
   sc_signal<Tcontrol_t>                  * in_NRESET = new sc_signal<Tcontrol_t> ("NRESET");
 
-    // ~~~~~[ Interface "memory_in" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+  sc_signal<Tcontrol_t        > **  in_MEMORY_IN_VAL                  ;
+  sc_signal<Tcontrol_t        > ** out_MEMORY_IN_ACK                  ;
+  sc_signal<Tcontext_t        > **  in_MEMORY_IN_CONTEXT_ID           ;
+  sc_signal<Tcontext_t        > **  in_MEMORY_IN_FRONT_END_ID         ;
+  sc_signal<Tcontext_t        > **  in_MEMORY_IN_OOO_ENGINE_ID        ;
+  sc_signal<Tpacket_t         > **  in_MEMORY_IN_PACKET_ID            ;
+  sc_signal<Toperation_t      > **  in_MEMORY_IN_OPERATION            ;
+  sc_signal<Ttype_t           > **  in_MEMORY_IN_TYPE                 ;
+  sc_signal<Tlsq_ptr_t        > **  in_MEMORY_IN_STORE_QUEUE_PTR_WRITE;
+  sc_signal<Tlsq_ptr_t        > **  in_MEMORY_IN_LOAD_QUEUE_PTR_WRITE ;
+  sc_signal<Tcontrol_t        > **  in_MEMORY_IN_HAS_IMMEDIAT         ;
+  sc_signal<Tgeneral_data_t   > **  in_MEMORY_IN_IMMEDIAT             ;
+  sc_signal<Tgeneral_data_t   > **  in_MEMORY_IN_DATA_RA              ;
+  sc_signal<Tgeneral_data_t   > **  in_MEMORY_IN_DATA_RB              ;
+  sc_signal<Tspecial_data_t   > **  in_MEMORY_IN_DATA_RC              ;
+  sc_signal<Tcontrol_t        > **  in_MEMORY_IN_WRITE_RD             ;
+  sc_signal<Tgeneral_address_t> **  in_MEMORY_IN_NUM_REG_RD           ;
+  sc_signal<Tcontrol_t        > **  in_MEMORY_IN_WRITE_RE             ;
+  sc_signal<Tspecial_address_t> **  in_MEMORY_IN_NUM_REG_RE           ;
+  sc_signal<Tcontrol_t        > ** out_MEMORY_OUT_VAL                 ;
+  sc_signal<Tcontrol_t        > **  in_MEMORY_OUT_ACK                 ;
+  sc_signal<Tcontext_t        > ** out_MEMORY_OUT_CONTEXT_ID          ;
+  sc_signal<Tcontext_t        > ** out_MEMORY_OUT_FRONT_END_ID        ;
+  sc_signal<Tcontext_t        > ** out_MEMORY_OUT_OOO_ENGINE_ID       ;
+  sc_signal<Tpacket_t         > ** out_MEMORY_OUT_PACKET_ID           ;
+//sc_signal<Toperation_t      > ** out_MEMORY_OUT_OPERATION           ;
+//sc_signal<Ttype_t           > ** out_MEMORY_OUT_TYPE                ;
+  sc_signal<Tcontrol_t        > ** out_MEMORY_OUT_WRITE_RD            ;
+  sc_signal<Tgeneral_address_t> ** out_MEMORY_OUT_NUM_REG_RD          ;
+  sc_signal<Tgeneral_data_t   > ** out_MEMORY_OUT_DATA_RD             ;
+  sc_signal<Tcontrol_t        > ** out_MEMORY_OUT_WRITE_RE            ;
+  sc_signal<Tspecial_address_t> ** out_MEMORY_OUT_NUM_REG_RE          ;
+  sc_signal<Tspecial_data_t   > ** out_MEMORY_OUT_DATA_RE             ;
+  sc_signal<Texception_t      > ** out_MEMORY_OUT_EXCEPTION           ;
+  sc_signal<Tcontrol_t        > ** out_MEMORY_OUT_NO_SEQUENCE         ;
+  sc_signal<Taddress_t        > ** out_MEMORY_OUT_ADDRESS             ;
+  sc_signal<Tcontrol_t        > ** out_DCACHE_REQ_VAL                 ;
+  sc_signal<Tcontrol_t        > **  in_DCACHE_REQ_ACK                 ;
+  sc_signal<Tcontext_t        > ** out_DCACHE_REQ_CONTEXT_ID          ;
+  sc_signal<Tpacket_t         > ** out_DCACHE_REQ_PACKET_ID           ;
+  sc_signal<Tdcache_address_t > ** out_DCACHE_REQ_ADDRESS             ;
+  sc_signal<Tdcache_type_t    > ** out_DCACHE_REQ_TYPE                ;
+  sc_signal<Tdcache_data_t    > ** out_DCACHE_REQ_WDATA               ;
+  sc_signal<Tcontrol_t        > **  in_DCACHE_RSP_VAL                 ;
+  sc_signal<Tcontrol_t        > ** out_DCACHE_RSP_ACK                 ;
+  sc_signal<Tcontext_t        > **  in_DCACHE_RSP_CONTEXT_ID          ;
+  sc_signal<Tpacket_t         > **  in_DCACHE_RSP_PACKET_ID           ;
+  sc_signal<Tdcache_data_t    > **  in_DCACHE_RSP_RDATA               ;
+  sc_signal<Tdcache_error_t   > **  in_DCACHE_RSP_ERROR               ;
+  sc_signal<Tcontrol_t        > ** out_BYPASS_MEMORY_VAL              ;
+  sc_signal<Tcontext_t        > ** out_BYPASS_MEMORY_OOO_ENGINE_ID    ;
+  sc_signal<Tgeneral_address_t> ** out_BYPASS_MEMORY_NUM_REG          ;
+  sc_signal<Tgeneral_data_t   > ** out_BYPASS_MEMORY_DATA             ;
+
   ALLOC1_SC_SIGNAL( in_MEMORY_IN_VAL                  ," in_MEMORY_IN_VAL                  ",Tcontrol_t        ,_param->_nb_inst_memory);
   ALLOC1_SC_SIGNAL(out_MEMORY_IN_ACK                  ,"out_MEMORY_IN_ACK                  ",Tcontrol_t        ,_param->_nb_inst_memory);
@@ -379,5 +432,6 @@
 	  tab_request[66].modif(550,0,0,0,65,OPERATION_MEMORY_LOAD_32_Z    ,TYPE_MEMORY,1,0,0x0  ,0x0          ,0x0       ,1,0,0,0x55508570); // just to wait the dcache_rsp
 
-	  const uint32_t nb_request = 64;//_param->_nb_packet;
+	  const uint32_t nb_request = 66;//_param->_nb_packet;
+// 	  const uint32_t nb_request = 64;//_param->_nb_packet;
         
 	  for (uint32_t i=0; i<nb_request; i++)
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/include/Load_store_unit.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/include/Load_store_unit.h	(revision 116)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/include/Load_store_unit.h	(revision 117)
@@ -157,7 +157,7 @@
 
     // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
-  protected : Tstore_queue_entry_t                                        * _store_queue;
-  protected : Tload_queue_entry_t                                         * _load_queue;
-  protected : Tspeculative_access_queue_entry_t                           * _speculative_access_queue;
+  protected : Tstore_queue_entry_t                                        * _store_queue                     ;//[size_store_queue]
+  protected : Tload_queue_entry_t                                         * _load_queue                      ;//[size_load_queue]
+  protected : Tspeculative_access_queue_entry_t                           * _speculative_access_queue        ;//[size_speculative_access_queue]
   protected : morpheo::behavioural::generic::queue_control::Queue_Control * _speculative_access_queue_control;
 
@@ -174,7 +174,8 @@
 
     // Registers
-  public    : Tlsq_ptr_t                      reg_STORE_QUEUE_PTR_READ;
-//public    : Tlsq_ptr_t                      reg_LOAD_QUEUE_PTR_READ ;
-  public    : Tlsq_ptr_t                      reg_LOAD_QUEUE_CHECK_PRIORITY ;
+  public    : Tlsq_ptr_t                    * reg_STORE_QUEUE_NB_CHECK     ;//[size_store_queue]
+  public    : Tlsq_ptr_t                      reg_STORE_QUEUE_PTR_READ     ;
+//public    : Tlsq_ptr_t                      reg_LOAD_QUEUE_PTR_READ      ;
+  public    : Tlsq_ptr_t                      reg_LOAD_QUEUE_CHECK_PRIORITY;
 
     // signal
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_allocation.cpp	(revision 116)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_allocation.cpp	(revision 117)
@@ -146,15 +146,25 @@
 
     // ~~~~~[ Internal ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    if (usage_is_set(_usage,USE_SYSTEMC))
+      {
+        _speculative_access_queue_control = new morpheo::behavioural::generic::queue_control::Queue_Control (_param->_size_speculative_access_queue);
 
-//     internal_SPECULATIVE_ACCESS_QUEUE_PTR_READ = new Tlsq_ptr_t [_param->_nb_cache_port];
+        ALLOC1(_store_queue             ,Tstore_queue_entry_t             ,_param->_size_store_queue);
+        ALLOC1(_load_queue              ,Tload_queue_entry_t              ,_param->_size_load_queue);
+        ALLOC1(_speculative_access_queue,Tspeculative_access_queue_entry_t,_param->_size_speculative_access_queue);
 
-//     internal_MEMORY_IN_ACK           = new Tcontrol_t      [_param->_nb_inst_memory];
-//     internal_MEMORY_OUT_VAL          = new Tcontrol_t      [_param->_nb_inst_memory];
-//     internal_MEMORY_OUT_SELECT_QUEUE = new Tselect_queue_t [_param->_nb_inst_memory];
-//     internal_MEMORY_OUT_PTR          = new Tlsq_ptr_t      [_param->_nb_inst_memory];
-    
-//     internal_DCACHE_RSP_ACK          = new Tcontrol_t      [_param->_nb_cache_port];
-//     internal_DCACHE_REQ_VAL          = new Tcontrol_t      [_param->_nb_cache_port];
-//     internal_DCACHE_REQ_SELECT_QUEUE = new Tselect_queue_t [_param->_nb_cache_port];
+        ALLOC1(reg_STORE_QUEUE_NB_CHECK                  ,Tlsq_ptr_t     ,_param->_size_store_queue);
+
+//      ALLOC1(internal_SPECULATIVE_ACCESS_QUEUE_PTR_READ,Tlsq_ptr_t     ,_param->_nb_cache_port);
+
+//      ALLOC1(internal_MEMORY_IN_ACK                    ,Tcontrol_t     ,_param->_nb_inst_memory);
+//      ALLOC1(internal_MEMORY_OUT_VAL                   ,Tcontrol_t     ,_param->_nb_inst_memory);
+//      ALLOC1(internal_MEMORY_OUT_SELECT_QUEUE          ,Tselect_queue_t,_param->_nb_inst_memory);
+//      ALLOC1(internal_MEMORY_OUT_PTR                   ,Tlsq_ptr_t     ,_param->_nb_inst_memory);
+                                                         
+//      ALLOC1(internal_DCACHE_RSP_ACK                   ,Tcontrol_t     ,_param->_nb_cache_port );
+//      ALLOC1(internal_DCACHE_REQ_VAL                   ,Tcontrol_t     ,_param->_nb_cache_port );
+//      ALLOC1(internal_DCACHE_REQ_SELECT_QUEUE          ,Tselect_queue_t,_param->_nb_cache_port );
+      }
 
     // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
@@ -164,9 +174,4 @@
       _component->generate_file();
 #endif
-
-    _store_queue                      = new Tstore_queue_entry_t              [_param->_size_store_queue];
-    _load_queue	                      = new Tload_queue_entry_t               [_param->_size_load_queue];
-    _speculative_access_queue         = new Tspeculative_access_queue_entry_t [_param->_size_speculative_access_queue];
-    _speculative_access_queue_control = new morpheo::behavioural::generic::queue_control::Queue_Control (_param->_size_speculative_access_queue);
 
     log_printf(FUNC,Load_store_unit,FUNCTION,"End");
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_deallocation.cpp	(revision 116)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_deallocation.cpp	(revision 117)
@@ -95,15 +95,22 @@
 
     // ~~~~~[ Internal ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    delete    _speculative_access_queue_control ;
     
-//     delete [] internal_MEMORY_IN_ACK          ;
-//     delete [] internal_MEMORY_OUT_VAL         ;
-//     delete [] internal_MEMORY_OUT_SELECT_QUEUE;
-//     delete [] internal_MEMORY_OUT_PTR         ;
-    
-//     delete [] internal_DCACHE_RSP_ACK         ;
-//     delete [] internal_DCACHE_REQ_VAL         ;
-//     delete [] internal_DCACHE_REQ_SELECT_QUEUE;
+    DELETE1(_store_queue             ,_param->_size_store_queue);
+    DELETE1(_load_queue              ,_param->_size_load_queue);
+    DELETE1(_speculative_access_queue,_param->_size_speculative_access_queue);
 
-//     delete [] internal_SPECULATIVE_ACCESS_QUEUE_PTR_READ;
+    DELETE1(reg_STORE_QUEUE_NB_CHECK                  ,_param->_size_store_queue);
+
+//  DELETE1(internal_SPECULATIVE_ACCESS_QUEUE_PTR_READ,_param->_nb_cache_port);
+
+//  DELETE1(internal_MEMORY_IN_ACK                    ,_param->_nb_inst_memory);
+//  DELETE1(internal_MEMORY_OUT_VAL                   ,_param->_nb_inst_memory);
+//  DELETE1(internal_MEMORY_OUT_SELECT_QUEUE          ,_param->_nb_inst_memory);
+//  DELETE1(internal_MEMORY_OUT_PTR                   ,_param->_nb_inst_memory);
+                                                     
+//  DELETE1(internal_DCACHE_RSP_ACK                   ,_param->_nb_cache_port );
+//  DELETE1(internal_DCACHE_REQ_VAL                   ,_param->_nb_cache_port );
+//  DELETE1(internal_DCACHE_REQ_SELECT_QUEUE          ,_param->_nb_cache_port );
       }
 
@@ -112,8 +119,4 @@
     delete    _component;
 
-    delete [] _store_queue                      ;
-    delete [] _load_queue	                ;
-    delete    _speculative_access_queue_control ;
-    delete [] _speculative_access_queue         ;
 
     log_printf(FUNC,Load_store_unit,FUNCTION,"End");
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_function_speculative_load_commit_genMoore.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_function_speculative_load_commit_genMoore.cpp	(revision 116)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_function_speculative_load_commit_genMoore.cpp	(revision 117)
@@ -98,5 +98,9 @@
       {
 	log_printf(TRACE,Load_store_unit,FUNCTION,"    * Store queue");
-	if (_store_queue [reg_STORE_QUEUE_PTR_READ]._state == STORE_QUEUE_COMMIT)
+        // Can retire an store instruction if :
+        //  * state is commit
+        //  * none load must check this store
+	if ((_store_queue [reg_STORE_QUEUE_PTR_READ]._state == STORE_QUEUE_COMMIT) and
+            (reg_STORE_QUEUE_NB_CHECK [reg_STORE_QUEUE_PTR_READ] == 0))
 	  {
 	    log_printf(TRACE,Load_store_unit,FUNCTION,"    * find : %d",reg_STORE_QUEUE_PTR_READ);
